<!--
@File Name          : listeUserstory.html
@Description        : 
@Author             : ChangeMeIn@UserSettingsUnder.SFDoc
@Group              : 
@Last Modified By   : ChangeMeIn@UserSettingsUnder.SFDoc
@Last Modified On   : 18/06/2020 à 21:24:30
@Modification Log   : 
Ver       Date            Author      		    Modification
1.0    30/05/2020   ChangeMeIn@UserSettingsUnder.SFDoc     Initial Version
-->
<template>
    <div class='slds-card slds-p-vertical_x-large'>
        <center class="bienvenue" style=" margin-block-end: -4%; font-size: 188%;
        margin-block-start: 3%;
        font-family: cursive;
        font-style: italic;
        color: navy;">
        <p><b> User Story Tables Assigned To The Project "{DetailProjet.Name}"</b></p><br/><br/>
        </center>
    <dl class="slds-list_inline" style="    margin-left: 14%; margin-block-end: 2%;">
        <dt class="slds-item_label slds-text-color_weak slds-truncate" style="font-weight: 900;
        font-style: italic;">Project Name:</dt>
        <dd class="slds-item_detail slds-truncate" >{DetailProjet.Name}</dd>
        
        <dt class="slds-item_label slds-text-color_weak slds-truncate" style="font-weight: 900;
        font-style: italic;" >Category:</dt>
        <dd class="slds-item_detail slds-truncate">{DetailProjet.Gat_gorie__c}</dd>
        
        <dt class="slds-item_label slds-text-color_weak slds-truncate" style="font-weight: 900;
        font-style: italic;">State:</dt>
        <dd class="slds-item_detail slds-truncate" >{DetailProjet.Etat__c}</dd>
        
        <dt class="slds-item_label slds-text-color_weak slds-truncate" style="font-weight: 900;
        font-style: italic;" >Type:</dt>
        <dd class="slds-item_detail slds-truncate" >{DetailProjet.Type__c}</dd>
        
        <dt class="slds-item_label slds-text-color_weak slds-truncate" style="font-weight: 900;
        font-style: italic;">Priority:</dt>
        <dd class="slds-item_detail slds-truncate" >{DetailProjet.Priorit__c}</dd>
        
        <dt class="slds-item_label slds-text-color_weak slds-truncate"  style="font-weight: 900;
        font-style: italic;">Start date:</dt>
        <dd class="slds-item_detail slds-truncate" >{DetailProjet.Date_Debut__c}</dd>
        
        <dt class="slds-item_label slds-text-color_weak slds-truncate" style="font-weight: 900;
        font-style: italic;">End date:</dt>
        <dd class="slds-item_detail slds-truncate" >{DetailProjet.Date_fin__c}</dd>
    </dl>
<dl class="slds-list_inline" style="margin-left: 21%;margin-block-end: 4%;">
    <dt class="slds-item_label slds-text-color_weak slds-truncate" style="font-weight: 900;
    font-style: italic;">Sprint Name:</dt>
    <dd class="slds-item_detail slds-truncate" >{detailSprint.Name}</dd>
    
    <dt class="slds-item_label slds-text-color_weak slds-truncate" style="font-weight: 900;
    font-style: italic;" >Description:</dt>
    <dd class="slds-item_detail slds-truncate">{detailSprint.Description__c}</dd>
    
    <dt class="slds-item_label slds-text-color_weak slds-truncate"  style="font-weight: 900;
    font-style: italic;">Start date:</dt>
    <dd class="slds-item_detail slds-truncate" >{detailSprint.Date_Debut__c}</dd>
    
    <dt class="slds-item_label slds-text-color_weak slds-truncate" style="font-weight: 900;
    font-style: italic;">End date:</dt>
    <dd class="slds-item_detail slds-truncate" >{detailSprint.Date_Fin__c}</dd>
</dl>
</br>
        <template if:true={openmodel}>
            <div class="demo-only">
                <section role="dialog" tabindex="-1" aria-labelledby="modal-heading-01" aria-modal="true" aria-describedby="modal-content-id-1" class="slds-modal slds-fade-in-open">
                    <div class="slds-modal__container">
                        <header class="slds-modal__header">
                            <button class="slds-button slds-button_icon slds-modal__close slds-button_icon-inverse" title="Close" onclick={closeModal}>
                                <lightning-icon icon-name="utility:close" size="medium">
                                </lightning-icon>
                                <span class="slds-assistive-text">Close</span>
                            </button>
                            <h2 id="modal-heading-01" class="slds-text-heading_medium slds-hyphenate">Ajouter un User Story</h2>
                        </header>
                        <div class="slds-modal__content slds-p-around_medium" id="modal-content-id-1">     
        <table>
            <tr>
            <td>
            <p>Project Name:</p>
            </td>
            <td>
            <lightning-input type="text" label=" "  required ="required"   value={DetailProjet.Name}  disabled ></lightning-input>
            </td>
            </tr>
            <TR> <TD> <lightning-input type="hidden"  placeholder="type here..."></lightning-input></TD></TR>
            <TR></TR>
            <tr>
            <td>
                <p>Sprint Name:</p>
            </td>
            <td>
            <lightning-input type="text" label=" "  required ="required"   value={detailSprint.Name}  disabled ></lightning-input>
            </td>
            </tr>
            <TR> <TD> <lightning-input type="hidden"  placeholder="type here..."></lightning-input></TD></TR>
            <TR></TR>
            <tr>
            <td>
                <p>User Story Name:</p>
            </td>
            <td>
            <lightning-input type="text" label=" " required ="required"  onchange={handleNameuserchange} value={UserStoryRecord.Name} placeholder="type here..."></lightning-input>
            </td>
            </tr>
            <TR> <TD> <lightning-input type="hidden"  placeholder="type here..."></lightning-input></TD></TR>
            <TR></TR>
            <tr>
            <td>
                <p>Description:</p>
            </td>
            <td>
            <lightning-input type="text" label=" "  required ="required"  onchange={handleDescriptionchange} value={UserStoryRecord.Description__c}  placeholder="type here..."></lightning-input>
            </td>
            </tr> 
            <TR> <TD> <lightning-input type="hidden"  placeholder="type here..."></lightning-input></TD></TR>
            <TR></TR>
            <tr>
            <td>
            <p>State:</p>
            </td>
            <td> 
                <lightning-combobox name="Etat__c"         
                label=" " value={value} placeholder="-Select-"
                options={pickListvalues} onchange={handleetatchange}>
            </lightning-combobox>
            </td>
            </tr> 
            </table>
        </div>
        <footer class="slds-modal__footer">
            <lightning-button label="cancel" variant="neutral" onclick={closeModal}></lightning-button>
            <lightning-button label="Save" variant="brand" onclick={saveMethod}></lightning-button>
        </footer>
        </div>
        </section>
        <div class="slds-backdrop slds-backdrop_open"></div>
        </div>
        </template>
        <lightning-button class="btt_ajouter" icon-name="utility:add" style="margin-left: 30%;" label="Add User Story" variat="brand" onclick={openmodal} ></lightning-button>
        <div style="    margin-block-start: 3px;
        margin-right: 58%;">
        <template if:true={data}>
            <lightning-datatable data={data}
            columns={columns}
            key-field="id"
            hide-checkbox-column="true"
            onrowaction={handleRowActions}></lightning-datatable>
        </template>
        </div>


        
        <div style="margin-inline-start: 42%;
        margin-inline-end: -25%;
        margin-block-start: -107px;">
        
        <template if:true={verifbool} >
           
            <lightning-layout multiple-rows="true" horizontal-align="spread">
                <lightning-layout-item padding="horizontal-small" size="12">
                </lightning-layout-item>
                
                <lightning-layout-item padding="horizontal-small" size="2">
                    <lightning-layout multiple-rows="true" >
                        
                        <lightning-layout-item size="12">
                            <lightning-card class="notStartedTasksLane">
                                <div slot="title" style="background-color: #a1b1ec;">Not Started</div>
                            </lightning-card>
                        </lightning-layout-item>
                   
                        <template if:true={verifbool}>
                            <template for:each={notStartedTasks} for:item="element">
                            <lightning-card icon-name="standard:task" key={element.Id} style="margin-left: -155%;">
                                <div slot="title">Name: {element.Name}</div>
                                <div class="slds-card__body slds-card__body_inner">
                                    <dl>
                                        <dt>
                                        <p key={element.Id}>Description: {element.Description__c}</p>
                                        </dt>
                                        <dt>
                                            <p key={element.Id}>Etat: {element.Etat__c}</p>
                                        </dt>
                                    </dl>
                                </div>
                                <div slot="actions">
                        <lightning-button-icon  key={element.Id} icon-name="utility:edit" onclick={editRecord}>Edit</lightning-button-icon>
                        </div>
                            </lightning-card>
                        </template>
                        </template>
                     
                    </lightning-layout>
                </lightning-layout-item>
           
                <lightning-layout-item padding="horizontal-small" size="2">
                    <lightning-layout multiple-rows="true" >
                        <lightning-layout-item size="12" style="margin-right: 66%;margin-left: -60%;" >
                            <lightning-card class="inProgressTasksLane" style="background-color: #efff9a;" >
                                <div slot="title" style="background-color: #efff9a;">In Progress</div>
                            </lightning-card>
                        </lightning-layout-item>
                        <template if:true={verifbool}>
                            <template for:each={inProgressTasks} for:item="element">
                            <lightning-card icon-name="standard:task" key={element.Id} style="margin-left: -177%; margin-top: 34%;">
                                <div slot="title">Name: {element.Name}</div>
                                <div class="slds-card__body slds-card__body_inner">
                                    <dl>
                                        <dt>
                                        <p key={element.Id}>Description: {element.Description__c}</p>
                                        </dt>
                                        <dt>
                                            <p key={element.Id}>Etat: {element.Etat__c}</p>
                                        </dt>
                                    </dl>
                                </div>
                                <div slot="actions" >
                                    <lightning-button-icon  key={element.Id} icon-name="utility:edit" onclick={editRecord}>Edit</lightning-button-icon>
                                </div>
                            </lightning-card>
                        </template>
                        </template>
                    </lightning-layout>
                </lightning-layout-item>
            
                <lightning-layout-item padding="horizontal-small" size="2">
                    <lightning-layout multiple-rows="true" >
                        <lightning-layout-item size="12" style=" margin-right: 136%;
                        margin-left: -121%;">
                            <lightning-card class="completedTasksLane" >
                                <div slot="title" style="background-color: #9bff7a;">Completed</div>
                            </lightning-card>
                        </lightning-layout-item>
                        <template if:true={verifbool}>
                        <template for:each={completedTasks} for:item="element">
                            
                            <lightning-card icon-name="standard:task" key={element.Id} style="    margin-top: 34%;margin-left: -251%;" >
                                <div slot="title">Name: {element.Name}</div>
                                <div class="slds-card__body slds-card__body_inner">
                                    <dl>
                                        <dt>
                                        <p key={element.Id}>Description: {element.Description__c}</p>
                                        </dt>
                                        <dt>
                                            <p key={element.Id}>Etat: {element.Etat__c}</p>
                                        </dt>
                                    </dl>
                                </div>
                                <div slot="actions">
                                <lightning-button-icon key={element.Id} icon-name="utility:edit" onclick={editRecord}>Edit</lightning-button-icon>
                                </div>
                            </lightning-card>
                        </template>
                        </template>
                    </lightning-layout>
                </lightning-layout-item>
                <lightning-layout-item padding="horizontal-small" size="2" >
                    <lightning-layout multiple-rows="true" >
                        <lightning-layout-item style="margin-left: -196%;margin-right: 196%;"  size="12">
                            <div style="background-color: #ec9090;">
                            <lightning-card  class="deferredTasksLane" >
                                <div slot="title" style="background-color: #ec9090;">Deferred</div>
                            </lightning-card>
                        </div>
                        </lightning-layout-item>
                        <template if:true={verifbool}>
                            <template for:each={deferredTasks} for:item="element">
                            <lightning-card icon-name="standard:task" key={element.Id} style="margin-left: -155%;">
                                <div slot="title">Name: {element.Name}</div>
                                <div class="slds-card__body slds-card__body_inner">
                                    <dl>
                                        <dt>
                                        <p key={element.Id}>Description: {element.Description__c}</p>
                                        </dt>
                                        <dt>
                                            <p key={element.Id}>Etat: {element.Etat__c}</p>
                                        </dt>
                                    </dl>
                                </div>
                                <div slot="actions">
                                    <lightning-button-icon  key={element.Id} icon-name="utility:edit" onclick={editRecord}>Edit</lightning-button-icon>
                                </div>
                            </lightning-card>
                        </template>
                        </template>
                </lightning-layout>
            </lightning-layout-item>
            </lightning-layout>
            </template>
            </div>
            <!-- Spinner -->
            <div if:true={showLoadingSpinner}>
            <lightning-spinner alternative-text="Loading" size="large"></lightning-spinner>
            </div>
            <!-- Detail view modal -->
            <template if:true={bShowModal}>
            <section role="dialog" tabindex="-1"
                    aria-labelledby="modal-heading-03"
                    aria-modal="true"
                    aria-describedby="modal-content-id-3"
                    class="slds-modal slds-fade-in-open">
            <div class="slds-modal__container">
                <!-- modal header -->
                <header class="slds-modal__header">
                    <button class="slds-button slds-button_icon slds-modal__close slds-button_icon-inverse" title="Close" onclick={closeModalAction}>
                        <lightning-icon icon-name="utility:close" alternative-text="close" variant="inverse" size="small" ></lightning-icon>
                    </button>
                    <h2 id="modal-heading-03" class="slds-text-heading_medium slds-hyphenate" if:false={isEditForm}>Record Detail</h2>
                    <h2 id="modal-heading-02" class="slds-text-heading_medium slds-hyphenate" if:true={isEditForm}>Update Record Values</h2>
                </header>
                <!-- modal body -->
                <div class="slds-modal__content slds-p-around_medium" id="modal-content-id-3" if:false={isEditForm}>
                    <dl class="slds-list_horizontal slds-wrap">
                        <dt class="slds-item_label slds-truncate" title="Nom de Projet">Nom de Projet:</dt>
                        <dd class="slds-item_detail slds-truncate">{DetailProjet.Name}</dd>
                        <dt class="slds-item_label slds-truncate" title="Nom de Projet">Nom de Sprint</dt>
                        <dd class="slds-item_detail slds-truncate">{detailSprint.Name}</dd>
                        <dt class="slds-item_label slds-truncate" title="Nom de User Story">Nom de User Story:</dt>
                        <dd class="slds-item_detail slds-truncate">{record.Name}</dd>
                        <dt class="slds-item_label slds-truncate" title="Description">Description:</dt>
                        <dd class="slds-item_detail slds-truncate">{record.Description__c}</dd>
                        <dt class="slds-item_label slds-truncate" title="Description">Etat:</dt>
                        <dd class="slds-item_detail slds-truncate">{record.Etat__c}</dd>
                    </dl>
                </div>
                
                <!-- showing record edit form -->
                <div if:true={isEditForm} class="slds-theme_default">
                    <lightning-record-edit-form layout-type="Full" record-id={currentRecordId} object-api-name="User_Story__c" onsubmit={handleSubmit} onsuccess={handleSuccess}>
                        <lightning-messages></lightning-messages>
                        <lightning-output-field field-name="Sprint__c"></lightning-output-field>
                        <lightning-input-field field-name="Name"></lightning-input-field>
                        <lightning-input-field field-name="Description__c"></lightning-input-field>
                        <lightning-input-field field-name="Etat__c"></lightning-input-field>
                        <br/>
                        <div style="text-align:center;">
                        <lightning-button class="slds-m-top_small"
                                            variant="brand"
                                            type="submit"
                                            name="update"
                                            label="Update Record"></lightning-button>
                    </div>
                </lightning-record-edit-form><br/>
                </div>
            <!-- modal footer start-->
            <footer class="slds-modal__footer" if:false={isEditForm}>
                <lightning-button variant="brand"
                                    label="Close"
                                    title="Close"
                                    onclick={closeModalAction}></lightning-button>
            </footer>
            </div>
            </section>
            <div class="slds-backdrop slds-backdrop_open"></div>
            </template>
    </div>
</template>